import QuickCheck
import Mate
import Monad
import System

instance Arbitrary Kind where
  arbitrary = oneof [ return King
                    , return Queen
                    , return Rook
                    , return Bishop
                    , return Knight
                    , return Pawn
                    ]

instance Arbitrary Colour where
  arbitrary = oneof [return Black, return White]

instance Arbitrary Board where
  arbitrary = liftM2 Board arbitrary arbitrary

main = do [n] <- getArgs
          mapM_ (\i -> check hard prop_checkmate) [1..read n]

hard :: Config
hard = Config
  { maxTest = 1000
  , maxFail = 10000
  , size    = (+ 3) . (`div` 2)
  , every   = \n args -> let s = show n in s ++ [ '\b' | _ <- s ]
  }
